<!DOCTYPE html>


<html lang="en">
    <head>
        <title>Websockets Application</title>
    </head>

    <body>
        <div class="center">
            <h1>Amazing Chat Application</h1>
            <h3 id="chat-header">Current in chat: General</h3>
            <h3 id="connection-header">Connection Status: Disconnected</h3>

            <form id="chat-selection">
                <label for="chatroom">Chat Room: </label>
                <input type="text" id="chatroom" name="chatroom"/><br/><br/>
                <input type="submit" value="Change ChatRoom"/>
            </form>
    
            <br/>
    
            <textarea class="messages" id="messages" readonly rows="10" cols="50" placeholder="Welcome to chatbox"></textarea>
    
            <br/>
    
            <form id="send-message">
                <label for="message">Message: </label>
                <input type="text" id="message" name="message"/><br/><br/>
                <input type="submit" value="Send Message"/>
            </form>
    

            <div style="border: 3px solid black;margin-top:30px">
                <form id="login-form">
                    <label for="username">Username: </label>
                    <input type="text" id="username" name="username"/><br/><br/>
                    <label for="password">Password: </label>
                    <input type="password" id="password" name="password"/><br/><br/>
                    <input type="submit" value="Login"/>
                </form>
            </div>
        </div>

       
    </body>

    <script>
        var selectedChat = "general";
        var conn;

        class Event {
            constructor(type, payload) {
                this.type = type;
                this.payload = payload;
            }
        }

        class SendMessageEvent {
            constructor(message, from) {
                this.message = message;
                this.from = from;
            }
        }

        class NewMessageEvent {
            constructor(message, from, sent) {
                this.message = message;
                this.from = from;
                this.sent = sent;
            }
        }

        class ChangeRoomEvent {
            constructor(name) {
                this.name = name;
            }
        }

        function routeEvent (event){
            if (event.type === undefined) {
                alert('no type field in the event')
            }

            switch (event.type) {
                case "new_message": 
                    const messageEvent = Object.assign(new NewMessageEvent, event.payload);
                    appendChatMessage(messageEvent);
                    break;
                default:
                    alert('unsupported message type');
                    break;
            }
        }

        function appendChatMessage(messageEvent) {
            var date = new Date(messageEvent.sent);
            const formattedMsg = `${date.toLocaleString()}: ${messageEvent.message}`;

            textarea = document.getElementById('messages');

            textarea.innerHTML = textarea.innerHTML + "\n" + formattedMsg;
            textarea.scrollTop = textarea.scrollHeight;
        }

        function sendEvent(eventName, payload) {
            const event = new Event(eventName, payload);

            conn.send(JSON.stringify(event));
        }

        function login(event){
            event.preventDefault();
            let formData = {
                username: document.getElementById("username").value,
                password: document.getElementById("password").value
            }

            fetch("/login", {
                method: "POST",
                headers: {
                    "Content-Type": "application/json" ,
                },
                body: JSON.stringify(formData),
                mode:"cors",
            }).then(response => {
                if (response.ok) {
                    return response.json();
                }else{
                    throw "unauthorized"
                }
            }).then(data => {
                // authenticated
                connectWebSocket(data.otp);
            }).catch(error => {
                alert(error);
            })

            return false
        }

        function connectWebSocket(otp) {
            if (window["WebSocket"]) {
                console.log("supported websockets");

                // connect to ws
                conn = new WebSocket("wss://"+document.location.host+"/ws?otp="+otp);
                
                conn.onopen = function(evt) {
                    document.getElementById("connection-header").innerHTML = "Connection Status: Connected";
                }

                conn.onclose = function(evt) {
                    document.getElementById("connection-header").innerHTML = "Connection Status: Disconnected";
                }


                conn.onmessage = function(evt) {
                    const eventData = JSON.parse(evt.data);

                    const event = Object.assign(new Event, eventData);

                    routeEvent(event);
                }
            } else {
                alert("Your browser does not support websockets");
            }
        }

        window.onload = function() {
            document.getElementById("chat-selection").addEventListener("submit", changeChatRoom);
            document.getElementById("send-message").addEventListener("submit", sendMessage);
            document.getElementById("login-form").addEventListener("submit", login);
        }

        function changeChatRoom(event) {
            event.preventDefault(); // Prevent form submission and page reload
            var newChatRoom = document.getElementById("chatroom");
            console.log(newChatRoom)
            if (newChatRoom != null && newChatRoom.value != selectedChat) {
                selectedChat = newChatRoom.value
                header = document.getElementById("chat-header").innerHTML = "Current in chat: " + selectedChat;

                let changeEvent = new ChangeRoomEvent(selectedChat);

                sendEvent("change_room", changeEvent);

                textarea = document.getElementById('messages');
                textarea.innerHTML = `You changed room into: ${selectedChat}`
            }
            return false;
        }

        function sendMessage(event) {
            event.preventDefault(); // Prevent form submission and page reload
            var newMessage = document.getElementById("message");
            if (newMessage != null && newMessage.value != "") {
                let outgoingEvent = new SendMessageEvent(newMessage.value, "admin");
                sendEvent("send_message", outgoingEvent);
            }
            return false;
        }

    </script>

    <style type="text/css">
        body{
            overflow: hidden;
            padding: 0;
            margin: 0;
            width: 100%;
            height: 100%;
            background-color: #f5f5f5;
        }

        .center {
            margin: auto;
            width: 50%;
            border: 3px solid green;
            padding: 10px;
        }
    </style>
</html>